﻿$(document).ready(function () {

    $.connection.stopWatchHub.client.runStopWatch = function () {
        runStopWatch();
    };

    $.connection.stopWatchHub.client.pauseStopWatch = function () {
        pauseStopWatch();
    };

    $.connection.stopWatchHub.client.resetStopWatch = function () {
        resetStopWatch();
    };

    $.connection.stopWatchHub.client.setSeconds = function (seconds) {
        setStopWatchSeconds(seconds);
    };

    $.connection.stopWatchHub.client.linkTicket = function (ticketREF) {
        setStopWatchTicketLink(ticketREF);
    };

    init();

    $('body').on('click', '.js-stop-watch-startPause', function (e) { //UI action
        if (stopWatchTimer) { //zastaveni
            pauseStopWatch();
            $.connection.stopWatchHub.server.pauseStopWatch();
        } else { //spusteni
            if (stopWatchSeconds == 0) { //spusteni od zacatku
                $("#dialog-track-time-record-for-stopwatch").data('action', 'start');
                OpenAddTrackTimeRecordDialog("#dialog-track-time-record-for-stopwatch", null, null, 'StopWatch', false);
            };

            runStopWatch();
            $.connection.stopWatchHub.server.runStopWatch();
        }
    });

    $('body').on('click', '.js-stop-watch-stop', function (e) { //UI action
        if (stopWatchSeconds > 0) {
            OpenAddTrackTimeRecordDialog("#dialog-track-time-record", "#trackTimeRecordSaveButton", null, 'Normal', true);
        }
    });

    $('body').on('click', '.js-stop-watch-edit', function (e) { //UI action
        $("#dialog-track-time-record-for-stopwatch").data('action', 'edit');
        OpenEditTrackTimeRecordDialog("#dialog-track-time-record-for-stopwatch", null, null, 'StopWatch', true);
    });

    $('body').on('click', '.js-stop-watch-cancel', function (e) { //UI action
        resetStopWatch();
        $.connection.stopWatchHub.server.resetStopWatch();
    });

    //from menu
    $('header .js-stop-watch-pause, header a .fa-pause-circle').click(function (e) {
        pauseStopWatch();
        $.connection.stopWatchHub.server.pauseStopWatch();
    });

    $('header .js-stop-watch-start, header a .fa-stopwatch, header a .fa-play-circle').click(function (e) {

        if (stopWatchSeconds == 0 && typeof ticketId !== 'undefined') { //jsem v detailu pozadavku
            $.ajax(
                RQ_URL + '/TrackTimeRecords/SaveTrackTimeRecordTicketDetail',
                {
                    data: JSON.stringify(
                        {
                            TrackTimeDialogType: 'StopWatch',
                            TicketId: ticketId,
                        }
                    ),
                    contentType: 'application/json',
                    type: 'POST',
                }
            );
        }

        if (stopWatchSeconds == 0) { //spoustim nove pocitadlo
            var tRef = typeof ticketREF !== 'undefined' ? ticketREF : null;  //jsem v detailu pozadavku //ticketREF je tam take definovan na strance
            setStopWatchTicketLink(tRef);
            $.connection.stopWatchHub.server.linkTicket(tRef);
        }
        //else { //spoustim pauznute pocitadlo
        //    //Ticket link neresim, necham jak je
        //}

        runStopWatch();
        $.connection.stopWatchHub.server.runStopWatch();
    });

}); //end document ready


var stopWatchSeconds = 0;
var stopWatchTimer = false;

//init
function init() {
    $.post(
        RQ_URL + '/TrackTimeRecords/GetStopWatch',
        function (data) {
            if (data != null) {
                setStopWatchSeconds(data.Seconds); //musi byt prvni

                switch (data.State) {
                    case 1: //Running
                        runStopWatch();
                        break;
                    case 2: //Paused
                        pauseStopWatch();
                        break;
                }

                setStopWatchTicketLink(data.TicketREF);
            }
        },
        "json"
    );
}

var originalTitle = document.title;

function stopWatchDisplayTime() {
    var time = moment().hour(0).minute(0).second(stopWatchSeconds).format('H:mm:ss');

    if (stopWatchSeconds >= 24 * 60 * 60) {
        time = Math.floor(stopWatchSeconds / 24 / 60 / 60) + 'd ' + time;
    }

    $('.js-stop-watch-time').text(time);
    document.title = time + ' - ' + originalTitle;
}

function stopWatchTick() {
    stopWatchSeconds++;
    stopWatchDisplayTime();
}

function runStopWatch() {
    $('.js-stop-watch-startPause .fa-play').hide();
    $('.js-stop-watch-startPause .fa-pause').show();
    $('button.js-stop-watch-startPause').prop('title', $('.js-stop-watch-startPause .fa-pause').prop('title'));
    $('button.js-stop-watch-dropdown').prop('disabled', false);

    $('header .dropdown-menu .js-stop-watch-start').hide();
    $('header .dropdown-menu .js-stop-watch-pause').show();
    $('header .dropdown-menu .js-stop-watch-stop').show();
    $('header a .fa-stopwatch').hide();
    $('header a .fa-play-circle').hide();
    $('header a .fa-pause-circle').show();

    if (stopWatchTimer) { //kdyby byly uz rozjete, zastavim je
        clearInterval(stopWatchTimer);
        stopWatchTimer = false;
    }

    if (!stopWatchTimer) {
        stopWatchTimer = setInterval(stopWatchTick, 1000);
        $('.js-menu-running-stopwatch').css('display', 'inline-block');
    }
}

function resetStopWatch() {
    $('.js-stop-watch-startPause .fa-pause').hide();
    $('.js-stop-watch-startPause .fa-play').show();
    $('button.js-stop-watch-dropdown').prop('disabled', true);

    $('.js-menu-running-stopwatch').hide();
    $('header .dropdown-menu .js-stop-watch-pause').hide();
    $('header .dropdown-menu .js-stop-watch-stop').hide();
    $('header .dropdown-menu .js-stop-watch-start').show();
    $('header a .fa-pause-circle').hide();
    $('header a .fa-play-circle').hide();
    $('header a .fa-stopwatch').show();

    $('.js-menu-stopwatch-dropdown-ticket').hide();
    $('.menu-stopwatch-ticket').hide();

    clearInterval(stopWatchTimer);
    stopWatchTimer = false;
    setStopWatchSeconds(0);
    document.title = originalTitle;
    setStopWatchTicketLink(null);
}

function pauseStopWatch() {
    $('.js-stop-watch-startPause .fa-pause').hide();
    $('.js-stop-watch-startPause .fa-play').show();
    $('button.js-stop-watch-startPause').prop('title', $('.js-stop-watch-startPause .fa-play').prop('title'));
    $('button.js-stop-watch-dropdown').prop('disabled', stopWatchSeconds == 0);

    $('header .dropdown-menu .js-stop-watch-pause').hide();
    $('header .dropdown-menu .js-stop-watch-start').show();
    $('header a .fa-stopwatch').hide();
    $('header a .fa-pause-circle').hide();
    $('header a .fa-play-circle').show();

    clearInterval(stopWatchTimer);
    stopWatchTimer = false;
    $('.js-menu-running-stopwatch').css('display', 'inline-block');
}

function setStopWatchTicketLink(tRef) {
    $('#aMenuStopWatchTicket').attr("href", RQ_URL + '/Tickets/Show/' + tRef);
    $('#lbMenuStopWatchTicket').text(tRef);
    $('.js-menu-stopwatch-dropdown-ticket').toggle(tRef != null);
    $('.menu-stopwatch-ticket').toggle(tRef != null);

    var ticketDetailREF = typeof ticketREF !== 'undefined' ? ticketREF : null;  //jsem v detailu pozadavku //ticketREF je tam take definovan na strance
    $(".js-ticketview-stopwatch-link").toggle(ticketDetailREF == tRef);

}

function setStopWatchSeconds(seconds) {
    stopWatchSeconds = seconds;
    stopWatchDisplayTime();
}
