﻿var selectedCategory = null;
var selectedSourceType = -1;
$(document).ready(function () {
    $('#coloPickerDiv').initColorpicker();
    $(".datepicker").datepicker();
    $(".timepicker").timepicker();

    $("#dialog-task").dialog({
        autoOpen: false,
        resizable: false,
        width: 1000,
        height: "auto",
        modal: true,
        buttons: [{
            id: "TaskSaveButton",
            text: Localization_Save,
            click: function () {
                var success = true;
                $("#NameTaskError").hide();
                if ($("#NameTask").val() == "") {
                    $("#NameTaskError").show();
                    success = false;
                }
                var data = createTrackTimeArray();
                if (success) {
                    $.ajax({
                        url: RQ_URL + '/Tasks/InsertOrEditTask',
                        data: JSON.stringify({
                            Id: $("#TaskId").val(),
                            RelatedTicketId: $("#TicketsTask").val(),
                            Description: $("#DescriptionTask").val(),
                            AssignedTo: $("#AssignedTo").length > 0 ? $("#AssignedTo").val() : "",
                            Name: $("#NameTask").val(),
                            TaskPriorityValue: $("#PriorityTask").val(),
                            Notification: $("#ReminderTask").is(":checked"),
                            NotificationDateInsertOrUpdate: $("#ReminderDateTask").val(),
                            NotificationTimeInsertOrUpdate: $("#ReminderTimeTask").val(),
                            StartDate: $("#StartDateTask").val(),
                            DueDate: $("#TermDateTask").val(),
                            SelectedCategory: $("#Category").val(),
                            TaskTrackTimeRecords: data,
                        }),
                        type: "POST",
                        contentType: "application/json; charset=utf-8",
                        success: function (event) {
                            $("#dialog-task").dialog("close");
                            $("#tasksForm").submit();
                        },
                    });
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-task-category-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/Tasks/DeleteCategory',
                    data: JSON.stringify({
                        Id: deleteId,
                    }),
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    success: function (event) {
                        $("#dialog-task-category-delete").dialog("close");
                        reloadCategory();
                    },
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-task-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/Tasks/DeleteTask',
                    data: JSON.stringify({
                        Id: deleteTaskId,
                    }),
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    success: function (event) {
                        $("#dialog-task-delete").dialog("close");
                        $("#tasksForm").submit(); //init ajax load after page load
                        $("#tasksCompletedForm").submit();
                    },
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-category").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            id: "CategorySaveButton",
            text: Localization_Save,
            click: function () {
                $("#NameTaskCategoryError").hide();
                if ($("#NameTaskCategory").val() == "") {
                    $("#NameTaskCategoryError").show();
                }
                else {
                    $.ajax({
                        url: RQ_URL + '/Tasks/NewOrUpdateCategory',
                        data: JSON.stringify({
                            Id: $("#IdCategory").val(),
                            Name: $("#NameTaskCategory").val(),
                            Hex: $("#ColorTaskCategory").val(),
                            Share: $("#ShareTaskCategory").is(":checked"),
                            ShareType: $('input[name=ShareTypeTaskCategory]:checked').val(),
                            Operators: $("#OperatorsTaskCategory").val(),
                            OperatorGroups: $("#OperatorGroupsTaskCategory").val(),
                        }),
                        type: "POST",
                        contentType: "application/json; charset=utf-8",
                        success: function (event) {
                            $("#dialog-category").dialog("close");
                            reloadCategory();
                        },
                    });
                }
            }
        }, {
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });


    $("#tasksForm").submit(); //init ajax load after page load
    $("#tasksCompletedForm").submit(); //init ajax load after page load

    $("#tasksDiv").on('change', '.checkbox-task', function () { //dynamically created elements - needs .on instead of .click event              
        var taskId = $(this).val();
        var checked = $(this).is(":checked");
        var tr = $(this).closest("tr");
        var task_complete_checkbox = $(this).closest(".task-complete-checkbox");

        $(task_complete_checkbox).addClass("loading-16");

        
        $.post(
        RQ_URL + '/Tasks/MarkComplete',
        { taskId: taskId, markComplete: checked },
        function (data) {
            $(task_complete_checkbox).removeClass("loading-16");
            tr.toggleClass("line-through");
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); })
        .success(function () {
            $("#tasksForm").submit();
            $("#tasksCompletedForm").submit();
        });
    });

    $("#tasksDiv").on("click", ".title", function () {
        $(".task-category").removeClass("selected");
        $(this).closest(".task-category").addClass("selected");
        selectedCategory = $(this).closest(".task-category").data("id") == undefined ? null : $(this).closest(".task-category").data("id");
        selectedSourceType = $(this).closest(".task-category").data("source");

        if (selectedSourceType == 2) {
            $("#AddQuickTask").css("visibility", "collapse");
        }
        else {
            $("#AddQuickTask").css("visibility", "visible");
        }

        $("#CategoryId").val(selectedCategory);
        $("#SourceType").val(selectedSourceType);
        $("#CompletedCategoryId").val(selectedCategory);
        $("#CompletedSourceType").val(selectedSourceType);

        $("#tasksForm").submit();
        $("#tasksCompletedForm").submit();
    });

    $("#tasksDiv").on("click", ".delete-task-category", function () {
        deleteCategor($(this).closest(".task-category").data("id"));
    });

    $("#tasksDiv").on("click", ".edit-task-category", function () {
        openEditCategoryDialog($(this).closest(".task-category").data("id"));
    });

    $("#tasksDiv").on('change', '#cbIncludeCompleted', function () { //dynamically created elements - needs .on instead of .click event              
        $("#tasksCompletedForm").submit();
    });

    $("#dialog-category").on('change', "#ShareTaskCategory", function () {
        if ($(this).is(":checked")) {
            $(".share-type-task-category").show();
        }
        else {
            $(".share-type-task-category").hide();
        }
    });

    $("#dialog-category").on('change', "#AllOperatorsTaskCategory", function () {
        if ($(this).is(":checked")) {
            $("#OperatorsTaskCategory").prop("disabled", true);
            $("#OperatorGroupsTaskCategory").prop("disabled", true);
        }
    });

    $("#dialog-category").on('change', "#SelectedOperatorsTaskCategory", function () {
        if ($(this).is(":checked")) {
            $("#OperatorsTaskCategory").prop("disabled", false);
            $("#OperatorGroupsTaskCategory").prop("disabled", false);
        }
    });

    $("#dialog-task").on("change", "#Category", function () {
        if ($(this).find("option:selected").data("share") == "True") {
            $(".assigned-to").show();
            var value = $("#AssignedTo").val();
            $(".assigned-to-select").html("<div class='loading-16'></div>");
            $(".assigned-to-select").load(RQ_URL + "/Tasks/LoadUsersForTask/" + $(this).val(), function () {
                if (value != undefined && value != null) {
                    $("#AssignedTo").val(value);
                }
            });
        }
        else {
            $(".assigned-to").hide();
        }
    });

    $("#dialog-task").on("change", "#ReminderTask", function () {
        if ($(this).is(":checked")) {
            $("#ReminderDateTask").prop("disabled", false);
            $("#ReminderTimeTask").prop("disabled", false);
        }
        else {
            $("#ReminderDateTask").prop("disabled", true);
            $("#ReminderTimeTask").prop("disabled", true);
        }
    });

    $(".body").on("click", ".deleteLink", function () {
        deleteTask($(this).closest("tr").data("id"));
    });

    $(".body").on("click", ".edit-task", function () {
        editTask($(this).closest("tr").data("id"));
    });

    $("body").on("click", ".change-sorting", function () {
        console.log($("#Sorting").length, $("#tasksForm").length);
        $("#Sorting").val($(this).data("sort"));
        $("#tasksForm").submit();
    });
});

function saveTask() {
    var success = true;
    $(".taskNameTopError").hide();
    if ($("#TaskNameTop").val() == "") {
        $(".taskNameTopError").show();
        success = false;
    }
    if (success) {
        $.ajax({
            url: RQ_URL + '/Tasks/InsertOrEditTask',
            data: JSON.stringify({
                Name: $("#TaskNameTop").val(),
                SelectedCategory: selectedCategory
            }),
            type: "POST",
            contentType: "application/json; charset=utf-8",
            success: function (event) {
                $("#tasksForm").submit();
                $("#TaskNameTop").val("");
            },
        });
    }
}

function createTrackTimeArray() {
    var divs = $("#tab_b").find(".track-time-row.value");
    var arrayData = Array();
    $.each(divs, function (index, value) {
        arrayData.push({
            Id: $(value).data("id"),
            DurationInSecond: $(value).find(".track-time-duration").data("duration"),
            DurationInString: $(value).find(".track-time-duration").data("durationstring"),
            Description: $(value).find(".track-time-description").data("description")
        })
    });
    return arrayData;
}

function initDraggable() {
    $("#ticketsFrame table tbody tr").draggable({
        helper: "clone",
        handle: ".image-draggable-task",
        start: function (e, ui) {
            $(ui.helper).addClass("ui-draggable-helper");
        }
    });
}

function openNewCategoryDialog() {
    $("#IdCategory").val("");
    $('#dialog-calendar').dialog('option', 'title', "Nová kategorie");
    $("#NameTaskCategory").val("");
    $("#ColorTaskCategory").val("#ffc");
    $("#ShareTaskCategory").prop("checked", false).trigger("change");
    $("#OperatorsTaskCategory").val(null);
    $("#OperatorGroupsTaskCategory").val(null);
    $("#AllOperatorsTaskCategory").prop("checked", true).trigger("change");
    $("#dialog-category").dialog("open");
    $("#CategorySaveButton span").text(Localization_Save);
}

function openEditCategoryDialog(id) {
    OnAjaxBegin("Načítám...");
    $("#IdCategory").val(id);
    $('#dialog-calendar').dialog('option', 'title', "Úprava kategorie");
    $("#CategorySaveButton span").text(Localization_Edit);
    $.ajax({
        url: RQ_URL + '/Tasks/GetCategory',
        data: JSON.stringify({
            Id: id,
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            $("#NameTaskCategory").val(data.Name);
            $("#ColorTaskCategory").val(data.Color);
            $("#ShareTaskCategory").prop("checked", data.Share).trigger("change");
            $('input[value=' + data.ShareType + ']').prop("checked", true).trigger("change");
            $("#OperatorsTaskCategory").val(data.Operators).trigger("change");
            $("#OperatorGroupsTaskCategory").val(data.OperatorGroups).trigger("change");
            OnAjaxComplete();
            $("#dialog-category").dialog("open");
        },
    });
}


var deleteId = -1;
var deleteTaskId = -1;

function deleteCategor(id) {
    deleteId = id;
    $("#dialog-task-category-delete").dialog("open");
}

function deleteTask(id) {
    deleteTaskId = id;
    $("#dialog-task-delete").dialog("open");
}

function editTask(id) {
    $("#dialog-task").html("<div class='loading-16'></div>")
    $("#dialog-task").load(RQ_URL + "/Tasks/EditTask/" + id, function () {
        $("#dialog-task").dialog("close");
        $("#dialog-task").dialog("open");
    });
    $("#dialog-task").dialog("open");
}

function reloadCategory() {
    $("#tasksDiv .left-box .categories").empty();
    $("#tasksDiv .left-box .categories").html("<div class='loading-16'></div>");
    $("#tasksDiv .left-box .categories").load(RQ_URL + "/Tasks/ReloadLeftBox/" + selectedCategory + "?source=" + selectedSourceType);
}

function changeTaskCategory(id, taskId) {
    $.ajax({
        url: RQ_URL + '/Tasks/ChangeCategory',
        data: JSON.stringify({
            Id: id,
            TaskId: taskId,
        }),
        type: "POST",
        contentType: "application/json; charset=utf-8",
        success: function (data) {
            $("#tasksForm").submit();
            reloadCategory();
        },
    });
}

function newTask() {
    $("#dialog-task").html("<div class='loading-16'></div>")
    $("#dialog-task").load(RQ_URL + "/Tasks/NewTask", function () {
        $("#dialog-task").dialog("close");
        $("#dialog-task").dialog("open");
        if (selectedCategory > 0) {
            $("#Category").val(selectedCategory).trigger("change");
        }
    });
    $("#dialog-task").dialog("open");
}

function ValidateTaskTrackTimeRecord() {
    $(".valid-error").hide();

    if ($("#tbTaskTrackTimeRecordDuration").val() == "") {
        $("#trackTaskTimeRecordDurationRequired").show();
    }
    else if (!ValidateTaskTrackTimeRecordDurationInput()) {
        $("#trackTaskTimeRecordDurationCorrectFormat").show();
    }
    else if ($("#tbTaskTrackTimeRecordDescription").val() == "") {
        $("#trackTaskTimeRecordDescriptionRequired").show();
    }
    else
        return true;

    return false;
}

function ValidateTaskTrackTimeRecordDurationInput() {
    var input = $("#tbTaskTrackTimeRecordDuration").val().replace(/ /g, '');
    var regex1 = new RegExp("^[0-9]+:[0-9]{1,2}$");
    var regex2 = new RegExp("^[0-9]+h[0-9]{1,2}m$");
    var regex3 = new RegExp("^[0-9]+m?$");
    var regex4 = new RegExp("^[0-9]+([,\.][0-9]+)?h$");
    return regex1.test(input) || regex2.test(input) || regex3.test(input) || regex4.test(input);
}

$.fn.initColorpicker = function () {
    $(this).colorpicker({
        colorSelectors: {
            'stickynote': '#ffffcc',
            'orange': '#f0ad4e',
            'green': '#5cb85c',
            'lightblue': '#5bc0de',
            'darkblue': '#337ab7',
            'lightred': '#d9534f',
            'darkred': '#b90600',
            'pink': '#ec2b8c',
            'purple': '#763f98',
            'default': '#7f7f7f',
            'chocolate': '#7B3F00',
        }
    })
    .on('changeColor', function (event) {
        $(this).find("input[type='text']").val(event.color.toHex());
    })
    .on('hidePicker', function (event) {
        $(this).find("input[type='text']").val(event.color.toHex());
    });
}